{$FORM TForm2, Unit2.sfm}

uses
  Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, 
  StdCtrls;

{###### Variables ###########}
{File Variables}
var F : Text;
    S : String;  
var i;
{InputQuery variables}
var qr,decision,decide;
{Chips, chip units, min chip settings}
var CU,chips,chips_set,Chip1,Chip2,Chip3,Chip4,Chip5,Chip6,Chip7,min_chip,chip_q;
{Print Variables}
var PT,pn,n,ds,nos;  
{Cash amounts variables}
var currency,start_amount,wish_amount,amount,stop_loss;
{Operation Variables}
var last_nr,unit_value,spin_count,fl_stop,was_betting,sim_mode;
{Element Variables}
var k_el,k_el1,el_n,ch_n,el_name;
var elements,elements_played,total_elements;
{###### End: Variables ######}

{#### Window Operations ##############################################}
procedure close_me;
begin
    if Self.Top<0 then Self.Top:=0;
    if Self.Left<0 then Self.Left:=0;
    AssignFile(F,'c:\rss-data\bv_winpos');
    Rewrite(F);              
    Writeln(F,Self.Top);
    Writeln(F,Self.Left);
    CloseFile(F); 
end;

procedure load_winpos;
begin
    AssignFile(F,'c:\rss-data\bv_winpos');{If no file exist. Then you will get an error message}
    Reset(F);{open the file for reading}
    i := 0;
    while not eof(F) do {loop that will repeat until the end of file will be not found}
    begin
        S:=ReadLn(F); {read the first line into "s" variable}
        if i=0 then Self.Top:=s;
        if i=1 then Self.Left:=s;
        i := i+1;
    end;
    CloseFile(F);//close the file
end;
{#### End: Window Operations #########################################}

{#### Memo Operations ################################################}
procedure marque(arg1,arg2);
begin
    Memo_BN.Lines.Insert(0,arg1);
    Memo_RN.Lines.Insert(0,arg2);
end;

procedure print_to_memo(arg1);
begin
    Memo_Res.Lines.Add(arg1);
end;
{#### End: Memo Operations ###########################################}

{#### toms_utils #####################################################}
procedure bet_x_on_y(xunits,yelements,chips);
{Author Silver; created in february 2009}
var k,x,y,x_knt;
begin
    //in your script chips must be declared like this
    //chips:=[0,0.01,0.1,0.5,1,10,25,100];
    xunits:=xunits*100;
    for k:=7 downto 1 do 
    begin //here we go through every chip
        if xunits>=(chips[k]*100) then 
        begin
        x_knt:=((xunits) div (chips[k]*100));//here we check how much chips[k] we must put
        for x:=1 to x_knt do 
        begin
            case k of
                1:click_chip1();
                2:click_chip2();
                3:click_chip3();
                4:click_chip4();
                5:click_chip5();
                6:click_chip6();
                7:click_chip7();
            end;
            for y:=0 to VarArrayHighBound(yelements,1) do 
            begin
                case yelements[y] of
                    {Even Chances}
'Red':click_red();
'Black':click_black();

'High':click_high();
'Low':click_low();

'Odd':click_odd();
'Even':click_even();

                    //here you can add other elements
                end;
            end;
            xunits:=xunits-(chips[k]*100);//here we reduce the xunits with the value of beted chips
            //ShowMessage('We bet chip '+FormatFloat('0.##',chips[k])+', remain to put '+FormatFloat('0.##',(xunits/100))+' units.');
            end;
        end;
    end;
end;

function in_array(i_nr,i_array):boolean;
{check if the i_nr value is from the i_array array}
var k;
begin
    result:=false;
    for k:=0 to VarArrayHighBound(i_array,1) do 
    begin
        if i_nr=i_array[k] then 
        begin
            result:=True;
            break;
        end;
    end;
end;

function number_is(number, name):boolean;
{check if the number is red, black ,etc.}
begin
    result:=false;
    
    case name of
{Even Chances}
'Red':  if in_array(number,[1,3,5,7,9,12,14,16,18,19,21,23,25,27,30,32,34,36])  then 
begin
    marque('',number);
    result:=True;
end;
'Black':if in_array(number,[2,4,6,8,10,11,13,15,17,20,22,24,26,28,29,31,33,35]) then 
begin
    marque(number,'');
    result:=True;
end;

'Odd':  if in_array(number,[1,3,5,7,9,11,13,15,17,19,21,23,25,27,29,31,33,35])  then result:=True;
'Even': if in_array(number,[2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36]) then result:=True;

'Low':  if in_array(number,[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18])      then result:=True;
'High': if in_array(number,[19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36]) then result:=True;
    end;//end: case name of
end;
{#### End: toms_utils ################################################}

{@@@@ Key element procedures @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
procedure el_init(ei_elements; var ei_elements);
begin
    for k_el:=0 to VarArrayHighBound(ei_elements,1) do 
    begin
        ei_elements[k_el,8]:=VarArrayHighBound(ei_elements[k_el,4],1)+1;//how much elelemnts we have in this row
        ei_elements[k_el,0]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 

        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,0,k_el1]:=0;//didn_apear
        fl_stop:=ei_elements[k_el,1,0]; 
        ei_elements[k_el,1]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 

        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,1,k_el1]:=fl_stop;//alerts
        ei_elements[k_el,2]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 

        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,2,k_el1]:=0;//cnt_progression
        fl_stop:=ei_elements[k_el,7,0]; ei_elements[k_el,7]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 

        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,7,k_el1]:=fl_stop;//play_cnt
        total_elements:=total_elements+ei_elements[k_el,8];
    end;
end;

procedure el_bet(eb_elements; var eb_elements);
begin
    for k_el:=0 to VarArrayHighBound(eb_elements,1) do begin
        for k_el1:=0 to eb_elements[k_el,8]-1 do begin
            if (eb_elements[k_el,0,k_el1]>=eb_elements[k_el,1,k_el1])and(eb_elements[k_el,7,k_el1]<>0) then begin //here we check if red didn't apear the wished spins and the play_cnt<>0
                eb_elements[k_el,2,k_el1]:=eb_elements[k_el,2,k_el1]+1;//if red didn't apear the wished numbers of spin we increase the cnt_progression
                if eb_elements[k_el,2,k_el1]=1 then print_to_memo('Start betting on '+eb_elements[k_el,4,k_el1]+'.');
                if eb_elements[k_el,2,k_el1]>VarArrayHighBound(eb_elements[k_el,5],1) then begin fl_stop:=1; break; end;; //here we check if we reach the end of progresion and loose, in this case the game stops
                if sim_mode<>1 then begin //if it is not the simulation mode
                    bet_x_on_y(eb_elements[k_el,5,eb_elements[k_el,2,k_el1]],[eb_elements[k_el,4,k_el1]],chips);//here we bet
                    was_betting:=1;
                end;
            end;
            if eb_elements[k_el,7,k_el1]=0 then elements_played:=elements_played+1;
        end;
    end;
end;

procedure stack_array(sa_elements; var sa_elements);
var k, k1;
begin
    for k:=0 to VarArrayHighBound(sa_elements,1) do 
    begin //b1
        for k1:=0 to sa_elements[k,8]-1 do 
        begin //b2
            if sa_elements[k,7,k1]=0 then continue;//in case play_cnt=0 we ignore this element
            if number_is(last_nr,sa_elements[k,4,k1]) then 
            begin //b3
                sa_elements[k,0,k1]:=0;//in case the red land counter is again 0
                if sa_elements[k,2,k1]>=1 then 
                begin //b4
                    if sa_elements[k,3]=-1 then 
                    begin //b5 in case we have voisins or orphelins
                        if sa_elements[k,4,k1]='orphelins' then 
                        begin //b6 in case we have orphelins
                            if last_nr=1 then 
                            begin//in case we have landed single1
                                amount:=amount+(sa_elements[k,5,sa_elements[k,2,k1]]*35)-(sa_elements[k,5,sa_elements[k,2,k1]]*4);
                            end else 
                            begin
                                if last_nr<>17 then amount:=amount+(sa_elements[k,5,sa_elements[k,2,k1]]*17)-(sa_elements[k,5,sa_elements[k,2,k1]]*4)//in case we have landed split
                                else amount:=amount+(sa_elements[k,5,sa_elements[k,2,k1]]*17*2)-(sa_elements[k,5,sa_elements[k,2,k1]]*3);//in case we have landed 17 - 2 splits won
                            end;
                        end else //b6
                        begin //b7 in case we have voisins
                            if in_array(last_nr,[0,2,3]) then 
                            begin
                                amount:=amount+(sa_elements[k,5,sa_elements[k,2,k1]]*11*2)-(sa_elements[k,5,sa_elements[k,2,k1]]*7);//in case we have landed street*2
                            end else 
                            begin
                                if in_array(last_nr,[25,26,28,29]) then amount:=amount+(sa_elements[k,5,sa_elements[k,2,k1]]*8*2)-(sa_elements[k,5,sa_elements[k,2,k1]]*7)//in case we have landed corner*2
                                else amount:=amount+(sa_elements[k,5,sa_elements[k,2,k1]]*17)-(sa_elements[k,5,sa_elements[k,2,k1]]*8);//in case we have landed some split
                            end;
                        end; //b7
                    end else //b5
                    amount:=amount+(sa_elements[k,5,sa_elements[k,2,k1]]*(sa_elements[k,3]-(sa_elements[k,6]-1)));//in case the red win we increase the amount
                    print_to_memo('Spin count - '+IntToStr(spin_count)+'. We have bet $'+FormatFloat('0.##',sa_elements[k,5,sa_elements[k,2,k1]])+' on '+sa_elements[k,4,k1]+' and win.');
                    if sa_elements[k,7,k1]<>-1 then sa_elements[k,7,k1]:=sa_elements[k,7,k1]-1;//we decrease the play_cnt
                end; //b4
                sa_elements[k,2,k1]:=0;//in case the red land cnt_progression became 0, so we again wait for red not to apear x times
            end else //b3
            begin
                if sa_elements[k,2,k1]>=1 then 
                begin
                    amount:=amount-(sa_elements[k,5,sa_elements[k,2,k1]]*sa_elements[k,6]);//in case the red lose we decrese amount with how much we bet on red
                    print_to_memo('Spin count - '+IntToSTr(spin_count)+'. We have bet $'+FormatFloat('0.##',sa_elements[k,5,sa_elements[k,2,k1]])+' on '+sa_elements[k,4,k1]+' and lose.');
                end;
                sa_elements[k,0,k1]:=sa_elements[k,0,k1]+1;//in case the red didn't land counter is increased
            end;
        end; //b2
    end; //b1
end;

procedure add_systems;{Note to self: Check the progressions in the elements for each system}
begin
elements:=[
[[0],[5],[0], 1,['Red','Black','High','Low','Odd','Even'],
[0,1,2,4,8,16,32,64,128,256,512],1,[-1],0]
];
end;
{@@@@ End: Key element procedures @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}

procedure setup_arrays;
begin
chips:=[0,0.01,0.1,0.5,1,10,25,100];
end;

procedure bet_RB;
begin
    click_chip1();
    click_red();
    click_black();
end;

procedure start_playing;
begin
    amount:=Edit_Balance.Text;
    print_to_memo(FormatFloat('0.##',amount));
    wish_amount:=StrToFloat(start_amount)+StrToFloat(Edit_Target.Text);
    print_to_memo(FormatFloat('0.##',wish_amount));
    while amount<wish_amount do 
    begin
        was_betting:=0;

        elements_played:=0;
        el_bet(elements,elements);
        
        if was_betting=0 then bet_RB;
        
        if (fl_stop=1)or(elements_played=total_elements) then break;
        
        click_spin_button();
        
        last_nr:=get_last_landed_number();
        
        stack_array(elements,elements);
        
        print_to_memo('Spin count - '+IntToSTr(spin_count)+'. Landed numbrer is '+IntToStr(last_nr)+'. Current amount is $'+FormatFloat('0.##',amount));
        print_to_memo('-------------------------------------------');
        //if amount<=stop_loss then break;
        Inc(spin_count);
    end;
end;

procedure Form2Close(Sender: TObject; var Action: TCloseAction);
begin
    close_me;     
end;

procedure Form2Activate(Sender: TObject);
begin
    load_winpos;
    add_systems;

    setup_arrays;

    start_amount:=Edit_Balance.Text;
    amount:=start_amount;//current amount became start_amount

    //wish_amount:=start_amount+Edit_Target.Text;
    wish_amount:=StrToFloat(start_amount)+StrToFloat(Edit_Target.Text); 
    stop_loss:=Edit_StopLoss.Text;

    elements_played:=0;
    el_init(elements,elements);

    spin_count:=1; 
    was_betting:=1; 
    fl_stop:=0;

    currency:='$';
    decision:='y';
    unit_value:=1;
end;

procedure Edit_BalanceKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
    start_amount:=Edit_Balance.Text;
end;

procedure Edit_TargetKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
    wish_amount:=StrToFloat(start_amount)+StrToFloat(Edit_Target.Text); 
end;        

procedure Edit_StopLossKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
    stop_loss:=Edit_StopLoss.Text;
end;

procedure Button_StopClick(Sender: TObject);
begin
    fl_stop:=1;    
end;

procedure Button_StartClick(Sender: TObject);
begin
    fl_stop:=0;
    memo_Res.Clear();
    start_playing;         
end;

begin
end;
